# Copyright 2013 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

from charmworld.jobs.ingest import IndexIngestJob
from charmworld.testing import factory
from charmworld.testing import (
    JobTestBase,
    temp_index_client,
)


class IndexIngestTest(JobTestBase):

    def test_basic_index(self):
        job = IndexIngestJob()
        with temp_index_client() as index_client:
            job.setup(index_client=index_client)
            ignore, charm = factory.makeCharm(self.db)
            job.run(charm)
            result = index_client._client.search(
                {}, index=index_client.index_name)
            doc = result['hits']['hits'][0]['_source']
            fields = ['name', 'description', 'summary']
            for field in [f for f in doc.keys() if f in fields]:
                self.assertEqual(doc[field], charm[field])
